#!/bin/bash
#
# General settings
#===================
datadir=/home/jum/wdir/ilcdaq/data
# 1 - chipnumber (as written on chip)
# 2 - pattern (default is rampup)
pattern=1
if [ $# == 0 ]; then
    chipnumber=0
elif [ $# == 1 ]; then
    chipnumber=$1
elif [ $# == 2 ]; then
    chipnumber=$1
    pattern=$2
else
    echo "Wrong number of arguments: " $#
    exit 1
fi
#
# Does not matter but set standard pca16 settings
# ===============================================
gain=0
shaper=0
polarity=1
#
# VXI settings
#=============
vxipath=$HOME/ilc/ilcdaq/chiptests/vxi11/bin
IP="192.168.4.10"
#
# select channel of pulsegenerator
#=================================
#USER1 : DC level
#USER2 : pulse for 12 and 16mV/fc = gain0 and gain2
#USER3 : 60% (12/20) of USER2 suitable 20 and 27mV/fC = gain1 and gain3
#USER4 : reverse polarity suitable for 12 and 16 mV/fc = gain0 and gain2
# Select quite mode to avoid possible noise
$vxipath/vxi11_send_verify $IP "SOURCE1:FUNCTION USER1" # DC level for pedestal runs and quite modes
$vxipath/vxi11_send_verify $IP "SOURCE2:FUNCTION USER1" # DC level for pedestal runs and quite modes
#
# SRU and MCM general settings
#=============================
dcladdress=0
chipaddress=7
mode=10
post=$((0 << 14))
pre=$((0 << 17))
above=$((0 << 12))
events=500
samples=`printf '%x' 1008`
channels=0
for register in {10..17}
do
    ./mcmwrreg --fec $dcladddress --register $register --write --value FFFF
done
mcmregister=`printf '%x' $((0x10 + $chipaddress))`
./saltrowrrdreg --fec $dcladdress --chip $chipaddress --register A --channel 0 --write $samples --verify
./mcmwrreg --fec $dcladdress --register $mcmregister --write --value $channels
#
# set readout mode of SALTRO chip
#================================
# Load 0 into VFPED as pedestal value - to all channels and chip
# Load 0 threshold to ZSTRH
for ch in {0..15}; do
    ./saltrowrrdreg  --fec $dcladdress  --chip $chipaddress --register 13 --channel $ch --write 0 --verify
    ./saltrowrrdreg  --fec $dcladdress --chip $chipaddress --register 8 --channel $ch --write 0 --verify
done
# Load DPCFG with mode = f(t) - fpd = 10,  postsamples (0-7), presamples (0-3), above threshold (0-3)
# To set back to normal mode mode=0.
value=`printf '%x' $((mode + post +pre + above))`
./saltrowrrdreg --bcast --fec $dcladdress --chip $chipaddress --register B --channel 0 --write $value --verify
# Set pretriggers=0, buffers=4
./saltrowrrdreg  --fec $dcladdress --chip $chipaddress --register C --channel 0 --write 0 --verify
#
# DATA taking
#============
./saltrobcmem --broadcast --fec $dcladdress --chip $chipaddress --pattern $pattern
datfile=`printf 'chip%d/saltro%d-ramp-mcm%d-c%d-p%d' $chipnumber $chipnumber $dcladdress $chipaddress $pattern`
echo "FILE= " $datfile
./mcmpca16 --fec $dcladdress --preamp 0 --gain $gain --shaper $shaper --shutdown 0 --polarity $polarity --write --verify
time ./srureadout --fec $dcladdress  --rate 0 --data ${datadir}/${datfile}.dat --event $events --softtrigger --sruif enp3s0
if [ ! -f ${datadir}/${datfile}.dat ]; then
        echo "ERROR datafile: $datfile.dat does not exist - exiting" >&2
        exit 2
fi
./sruunpack --data ${datadir}/${datfile}.dat --root --dump > ramp.out
rootfile=`printf 'chip%d/saltro%d-ramp-mcm%d-c%d-p%d' $chipnumber $chipnumber $dcladdress $chipaddress $pattern`
if [ ! -f ${datadir}/${rootfile}.root ]; then
    echo "ERROR rootfile : $rootfile.root does not exist - exiting" >&2
    exit 3
fi
title=`printf 'pattern%d' $pattern`
./plotchipramp.exe $chipnumber $dcladdress $chipaddress ${pattern} ${datadir} ${rootfile} ${title}
value=$?
if [ $value -ne 0 ] 
then
    echo "ERROR: ./plotchipzsuppeaks.exe returned ${value}" >&2
fi

csvfile=${datadir}/${rootfile}.csv
if [ $chipnumber != 0 ]; then
    if [ -f ${csvfile} ]; then
        mydate=`date +%Y%m%d%H%M%S`
        echo "$csvfile exist" $mydate
        destfile=${mydata}/${rootfile}-${mydate}.csv
        mv $csvfile $destfile
    fi
else
    echo "TESTRUN - manage csvfile by hand"
fi

exit 0

